# coding: utf8
# # sample index page with internationalization (T)
from applications.Demexp.modules.fonctions_div import *

def index():
    if not session.m:
        session.flash="!!! ATTENTION !!! Site en cours de TESTS merci de votre compréhention et participation."
    if not session.groupe:session.groupe='Public'

    redirect(URL(r=request,f='listes'))
    return dict()
    
def aide():
    return dict(message="ici une page d'aide... pour le moment Version au: 24 octobre 2009 ")
    
def non_membre():
    session.groupe='Public' 
    return dict(message="accès réservé aux membres...")                
    
@auth.requires_login()
def vote():
    #si le vote n'est pas valide (bulletin créé en Question X et voté en Question Y..(avec plusieurs questions ouvertes))
    if request.args[0]!=session.q:
        session.flash="vote NON VALIDE ! vous devez voter dans la zone du dernier bulletin préparé %s %s" %(request.args[0],session.q)
        redirect(URL(r=request,f="listes"))

    la_Q=db(db.Questions.id==request.args[0]).select()[0]
    #si date de cloture dépassée 
    if la_Q.date_limite<request.now:
        session.flash="LA DATE DE CLOTURE POUR CETTE QUESTION EST DEPASEE...désolé,vous ne pouvez pas voter !"
        redirect(URL(r=request,f="listes"))

    #si le vote est valide    
    bulletin=''.join(session.v)
    old_vote=(db.Votes.U_id==auth.user.id)&(db.Votes.Q_id==request.args[0])
    
    if not session.d:session.d=0  #si vote non délégué =>0
    #si ancien vote existant
    if len(db(old_vote).select())>0:
        for v in db(old_vote).select():          
            old_bulletin=v.Buletin                                          
            old_matchs=matching(request.args[0],old_bulletin,v.date_vote)
            
        db(old_vote).update(D_id=session.d,
                            Buletin=bulletin,
                            date_vote=request.now)
                            
        matchs=matching(request.args[0],bulletin,request.now)
        update_resultat(request.args[0],matchs,old_matchs)
        session.flash="Votre vote a été mis à jour..."
    #si pas d'ancien vote    
    else:
        vote_id=db.Votes.insert(Q_id=request.args[0],
                                U_id=auth.user.id,
                                D_id=session.d,
                                Buletin=bulletin,
                                date_vote=request.now)
        ##la_Q=db(db.Questions.id==request.args[0]).select()[0] 
        matchs=matching(request.args[0],bulletin,request.now)                       
        db(db.Questions.id==request.args[0]).update(nbr_votes=la_Q.nbr_votes+1)
        update_resultat(request.args[0],matchs)
        
        session.flash="Votre vote a été enregistré..." 
    session.d=0 #annulation de la délégation éventuelle pour la suite
    redirect(URL(r=request,f="listes"))
    return dict()
    

    
def update_resultat(Q_id,matchs,old_matchs=[]):
    resultat={}
    la_Q=db(db.Questions.id==Q_id).select()[0]
    resultat=str_to_dict(la_Q.resultat)
    old_resultat=resultat.copy()
    #on décrémente les anciens matchs
    for m in old_matchs:
        resultat[m]=resultat[m]-1
    #on incrémente les nouveaux matchs    
    for m in matchs:
        try:
            resultat[m]+=1
        except:
            resultat[m]=1
        
    db(db.Questions.id==Q_id).update(resultat=resultat)
    #session.flash="matchs... %s vers %s  ** resultat...%s  vers %s" %(old_matchs,matchs,old_resultat,resultat)
    
def matching(Q_id,bulletin,date_vote):
    matchs=[]
    liste_rns=[]
    #liste des réponses sélectionnées
    liste=bulletin.split('_')[1:]
    
    #liste des réponses non sélectionnées
    #prise en compte de la date pour les mises à jour (pour ne pas annuler un match sur question inexistante au temps du vote...)
    for j in  db(db.Reponses.Q_id==Q_id).select(db.Reponses.ALL):
        if str(j.id) not in liste and j.date_postee<=date_vote:
            liste_rns.append(str(j.id))
        
    liste_b=liste+liste_rns
    for r in liste:
        for r2 in liste_b[liste_b.index(r)+1:]:
            couple=r+'>'+r2
            matchs.append(couple)
    return matchs


    
@auth.requires_login()    
def new_Q():
    liste_groupes=get_user_groupes(auth.user.id)
        
    form=FORM(TABLE(TR("Votre question:",
                       TEXTAREA(_name="new_desc",requires=(IS_NOT_EMPTY()))),
                    TR("Date limite :",
                       INPUT(_id="datelimite",_name="datelimite",_class="datetime",requires=IS_DATETIME())),
                    TR("Choisissez un groupe de publication:",
                       SELECT(liste_groupes,_id="groupe",_name="groupe",requires=IS_IN_SET(liste_groupes))),
                    TR(INPUT(_type='submit',_value='Valider')))) 
    if form.accepts(request.vars,session):
        final_Q=form.vars.new_desc.strip().lower().capitalize()
        Q_id=db.Questions.insert(description=final_Q,date_limite=form.vars.datelimite,groupe=form.vars.groupe)
        session.flash="Nouvelle Question prise en compte.."
        redirect(URL(r=request,f="listes",args=['Tous']))
    return dict(form=form)
    
    
@auth.requires_login()
def new_R():
    db.Reponses.Q_id.default=request.args[0]
    form=FORM(TABLE(TR('Votre proposition :',
                       INPUT(_type='text',_style="width:600px",_name="new_rep",requires=(IS_NOT_EMPTY())),
                       INPUT(_type='submit',_value='Valider'))))    
    if form.accepts(request.vars,session):
        final_rep=form.vars.new_rep.strip().lower().capitalize()
        rep_id=db.Reponses.insert(titre=final_rep)
        
        session.flash="Nouvelle Réponse prise en compte.."
        redirect(URL(r=request,f="listes"))
        
    row=db(db.Questions.id==request.args[0]).select(db.Questions.ALL)[0]
    question=row.description
        
    return dict(Q_id=request.args[0],question=question,form=form)
    
@auth.requires_login()  #membership('Administrateurs')
def new_T():
    tags_existants=[]
    tags=db().select(db.Tags.ALL)
    for t in tags:
        tags_existants.append(t.titre)
    #tags_existants=tags_existants.sort()
    
    form = FORM(TABLE(TR('Nouveau Sujet:', INPUT(_type='text', _name='tag',requires=(IS_NOT_EMPTY(),IS_NOT_IN_DB(db,'Tags.titre'))),
                                           INPUT(_type='submit',_value='Valider'))))

    if form.accepts(request.vars,session):
        final_tag=form.vars.tag.strip().lower().capitalize()

        if final_tag in tags_existants or final_tag=='Tous' :
            session.flash = 'Sujet non valide ou existant'
            redirect(URL(r=request,f="listes"))
        else:
            tags_id=db.Tags.insert(titre=form.vars.tag)
            session.flash="Nouveau Tag créé..."
            redirect(URL(r=request,f="listes"))
    elif form.errors:
        session.flash = 'Sujet non valide ou existant'
        redirect(URL(r=request,f="listes"))
    return dict(tags_existants=tags_existants,form=form)

@auth.requires_login()
def add_T():
    message=''
    existe=0
    db.Tags_Questions.Q_id.default=request.args[0]
    form=SQLFORM(db.Tags_Questions)
    if form.accepts(request.vars,session):
        for Tnum in db(db.Tags_Questions.Q_id==request.args[0]).select(db.Tags_Questions.ALL):
            if str(Tnum.T_id)==form.vars.T_id:
                existe+=1
                if existe>1:
                    db(db.Tags_Questions.id==form.vars.id).delete()
                    message="existait déjà"
        session.flash="Nouveau Tag pris en compte...%s" %message
        redirect(URL(r=request,f="listes"))
    return dict(form=form)

def get_user_groupes(U_id):
    #Renvoi une liste des groupes auquels U_id appartient + Public
    liste_groupes_id=db(db.auth_membership.user_id==U_id).select(db.auth_membership.ALL)
    liste_groupes=['Public']
    for g in liste_groupes_id:
        gp=db(db.auth_group.id==g.group_id).select(db.auth_group.ALL)[0] 
        liste_groupes.append(gp.role)
    return liste_groupes
    
def listes():
    #if request.args:
    if not session.aut:session.aut=('Tous','Tous') # (id,nom)
    if not session.groupe:session.groupe='Public'
    if not session.tag:session.tag='Tous'
    
    if session.tag != 'Tous':   
        t=db(db.Tags.titre==session.tag).select(db.Tags.ALL)[0] 
        tag_id=t.id
        
    if session.tag=='Tous':
        if session.aut[0]=='Tous':       
            questions=db((db.Questions.visibilite=='True')
                         &(db.Questions.groupe==session.groupe)).select(db.Questions.ALL)
        else:
            questions=db((db.Questions.auteur_id==session.aut[0])
                         &(db.Questions.groupe==session.groupe)
                         &(db.Questions.visibilite=='True')).select(db.Questions.ALL)
    else:
        if session.aut[0]=='Tous':       
            questions=db((db.Questions.visibilite=='True')
                        &(db.Questions.groupe==session.groupe)
                        &(db.Tags_Questions.T_id==tag_id)
                        &(db.Tags_Questions.Q_id==db.Questions.id)).select(db.Questions.ALL)
        else:
            questions=db((db.Tags_Questions.T_id==tag_id)
                        &(db.Questions.groupe==session.groupe)
                        &(db.Tags_Questions.Q_id==db.Questions.id)
                        &(db.Questions.auteur_id==session.aut[0])
                        &(db.Questions.visibilite=='True')).select(db.Questions.ALL)

    #Sélecteurs  ******************
    #de Tags 
    dico_tags={'Tous':'Tous'}
    liste_tags=['Tous']
    for t in db().select(db.Tags.ALL):
        liste_tags.append(t.titre)
    liste_tags.sort()
    liste_tags.reverse()
    liste_tags.remove(session.tag)
    liste_tags.append(session.tag)
    liste_tags.reverse()
            
    #d'Auteurs------------------------------------------------------------------
    dico_auts={'Tous':'Tous'}
    for q in db().select(db.Questions.ALL):
        if q.auteur_id not in dico_auts.keys():
            a=db(db.auth_user.id==q.auteur_id).select(db.auth_user.ALL)[0]
            auteur=a.first_name+' '+a.last_name
            dico_auts[q.auteur_id]=auteur
            
    liste_auts=[session.aut[1]]
    for a in dico_auts.keys():
        if a != session.aut[0] and dico_auts[a] not in liste_auts:
            liste_auts.append(dico_auts[a])
            
    #de groupes-------------------------------------------------------------------
    if auth.is_logged_in():        
        liste_groupes=get_user_groupes(auth.user.id)   
        liste_groupes.sort()
        liste_groupes.reverse()
        liste_groupes.remove(session.groupe)
        liste_groupes.append(session.groupe)
        liste_groupes.reverse()
    else:
        liste_groupes= ['Public']   
            
    form_choix_T=FORM(TABLE(TR("Sélection par: Sujet ",SELECT(liste_tags,_name="Tag_choisi",requires=IS_IN_SET(liste_tags)),
                               "Auteur  ",SELECT(liste_auts,_name="Aut_choisi",requires=IS_IN_SET(liste_auts)),
                               "Groupe  ",SELECT(liste_groupes,_name="Groupe_choisi",requires=IS_IN_SET(liste_groupes)),
                               "",     INPUT(_type="submit",_value="Envoi"))))
                               
    if form_choix_T.accepts(request.vars,session): 
        session.tag=form_choix_T.vars.Tag_choisi
        session.groupe=form_choix_T.vars.Groupe_choisi 
        
        for a in dico_auts:
            if dico_auts[a]==form_choix_T.vars.Aut_choisi:
                session.aut=(a,dico_auts[a])
                
        if session.groupe !='Public':
            #session.flash='entrée sollicitée pour groupe %s' %session.groupe
            redirect(URL(r=request,f='sas'))
        redirect(URL(r=request,f='listes')) 
    return dict(questions=questions,form_choix_T=form_choix_T)

def data():
    #Utilisée pour la mise à jour de la liste des réponses sélectionnées (Ajax)
    if not session.m:session.m=[]
    if not session.v:session.v=[]
    for clef in request.vars:
        if 'champ' in clef:
            q=clef[5:clef.find('_')]
            if not session.q or session.q!=q:
                session.m=[]
                session.v=[]
                session.q=q
            r=clef[clef.find('_'):]
            if request.vars[clef] in session.m:
                idx=session.m.index(request.vars[clef])
                del(session.m[idx])
                del(session.v[idx])
            session.m.append(request.vars[clef])
            session.v.append(r)
    return TABLE(*[TR(v) for v in session.m]).xml()
    
def clear_target():
    #Nettoyage de la Zone "target" d'affichage des réponses sélectionnées
    session.m=[]
    session.v=[]
    
    return TABLE(*[TR(v) for v in session.m]).xml()

#@auth.requires_login()
@auth.requires_membership(session.groupe)
def sas():
    response.flash="vous êtes maintenant connecté au groupe %s" %session.groupe
    gpe=db(db.auth_group.role==session.groupe).select(db.auth_group.ALL)[0]
    
    if auth.has_permission('create_'+str(gpe.id),'auth_membership'):
        #Récupération des postulants désireux d'integer le groupe 
        postulants=db(db.Postulants.G_id==gpe.id).select(db.Postulants.ALL)
        liste_postulants=[]
        liste_id=[]    
        for p in postulants:
            donne=db(db.auth_user.id==p.U_id).select(db.auth_user.ALL)[0]
            nom=donne.first_name+" "+donne.last_name+" : "+p.Motivation
            liste_postulants.append(nom)
            liste_id.append(p.U_id)

        if liste_id==[]:
            redirect(URL(r=request,f='listes'))
        
        #Acceptation ou non  de leur inscription 
        #form=SQLFORM.factory(SQLField('Postulants',requires=IS_IN_SET(liste_id,(liste_postulants)),
        #                              widget=SQLFORM.widgets.checkboxes.widget)) 
        form=SQLFORM.factory(SQLField('Postulants',requires=IS_IN_SET(liste_id,(liste_postulants),multiple=True),
                                      widget=SQLFORM.widgets.checkboxes.widget)) 

        if form.accepts(request.vars,session):
            acceptes=form.vars.Postulants.split('|')
            while '' in acceptes:
                acceptes.remove('')
            for p in acceptes:
                auth.add_membership(gpe.id,p)
                if gpe.adhesion=="parrainée":
                    auth.add_permission(auth.id_group('user_'+str(p)),'create_'+str(gpe.id),'auth_membership',0)
                ## "administrée"...
                db((db.Postulants.G_id==gpe.id)&(db.Postulants.U_id==p)).delete()
            redirect(URL(r=request,f='listes'))
        if form.errors:
            redirect(URL(r=request,f='listes'))    
    else:
        redirect(URL(r=request,f='listes'))    
    return dict(form=form)           
        
# # uncomment the following if you have defined "auth" and "crud" in models
# def data(): return dict(form=crud())
# def download(): return response.download(request,db)
# # tip: use @auth.requires_login, requires_membership, requires_permission

#########################################################################
## This is a samples controller
## - index is the default action of any application
## - user is required for authentication and authorization
## - download is for downloading files uploaded in the db (does streaming)
## - call exposes all registered services (none by default)
#########################################################################  



def user():
    if request.args[0]=='logout':
        session.groupe='Public'
    """
    exposes:
    http://..../[app]/default/user/login 
    http://..../[app]/default/user/logout
    http://..../[app]/default/user/register
    http://..../[app]/default/user/profile
    http://..../[app]/default/user/retrieve_password
    http://..../[app]/default/user/change_password
    use @auth.requires_login()
        @auth.requires_membership('group name')
        @auth.requires_permission('read','table name',record_id)
    to decorate functions that need access control
    """
    return dict(form=auth())


def download():
    """
    allows downloading of uploaded files
    http://..../[app]/default/download/[filename]
    """
    return response.download(request,db)


def call():
    """
    exposes services. for example:
    http://..../[app]/default/call/jsonrpc
    decorate with @services.jsonrpc the functions to expose
    supports xml, json, xmlrpc, jsonrpc, amfrpc, rss, csv
    """
    return service()
