# coding: utf8
@auth.requires_login()
def groupes_accueil():
    #Liste des groupes existants
    liste=[]
    descriptions=[]
    membres=[]
    adhesions=[]
    tous_groupes_id=db((db.auth_group.id>=0)&(db.auth_group.key>0)).select(db.auth_group.ALL)
    for gp in tous_groupes_id:
        liste.append(gp.role)
        descriptions.append(gp.description)
        membres.append(len(db((db.auth_membership.group_id==gp.id)&(db.auth_membership.user_id>=0)).select(db.auth_membership.user_id)))
        adhesions.append(gp.adhesion)
        
    form=SQLFORM.factory(SQLField('Choisir',requires=IS_IN_SET(('Créer','Adhérer')),widget=SQLFORM.widgets.radio.widget))
    if form.accepts(request.vars,session):
        if form.vars.Choisir=='Créer':    
            redirect(URL(r=request,c="groupes",f='new_G'))
        if form.vars.Choisir=='Adhérer':     
            redirect(URL(r=request,c="groupes",f='inscription'))
    if form.errors:
        redirect(URL(r=request,c='default',f='listes'))               
    return dict(liste=liste,descriptions=descriptions,membres=membres,adhesions=adhesions,form=form)

@auth.requires_login()    
def new_G():
    form=SQLFORM(db.auth_group)
    form.vars.key=1
    if form.accepts(request.vars,session):
        response.flash="Nouveau groupe %s créé !" %form.vars.role 
        auth.add_membership(form.vars.id,auth.user.id)
        #guu=db(db.auth_group.role=='user_'+str(auth.user.id)).select(db.auth_group.id)[0]
        guu=auth.id_group('user_'+str(auth.user.id))
        auth.add_permission(guu,'create_'+str(form.vars.id),'auth_membership',0)
        redirect(URL(r=request,c='default',f='index',args=['Tous']))
    return dict(message="page de création de groupe",form=form)
    
@auth.requires_login()    
def inscription():
    sel=get_non_user_groupes(auth.user.id)
    liste=sel[1]
    liste_id=sel[0]
    #form=SQLFORM(db.Postulants)
    form=FORM(TABLE(TR("Sélectionnez un Groupe:",SELECT(liste,_name="Groupe_choisi",requires=IS_IN_SET(liste))),
                    TR("Motivez votre demande ci dessous"),
                    TR(TEXTAREA (style="width: 200px",_name="Motivation")),                   
                    TR(   "",     INPUT(_type="submit",_value="Envoi"))))
                               
    if form.accepts(request.vars,session): 
        groupe=form.vars.Groupe_choisi 
        G_id=liste_id[liste.index(groupe)]
        Motivation=form.vars.Motivation
        post_id=db.Postulants.insert(G_id=G_id,
                                     Motivation=Motivation,
                                     U_id=auth.user.id) 

        response.flash="Votre demande a été transmise "  
        redirect(URL(r=request,c='default',f='index',args=['Tous']))
    return dict(form=form)

def get_non_user_groupes(U_id):
    #Renvoi une liste des groupes auquels U_id n'appartient pas
    appartient=[]
    liste_groupes_id=db(db.auth_membership.user_id==U_id).select(db.auth_membership.group_id)
    for g in liste_groupes_id:
        appartient.append(g.group_id)
    tous_groupes_id=db((db.auth_group.id>=0)&(db.auth_group.key>0)).select(db.auth_group.ALL)
    
    liste_groupes=[]
    liste_id=[]
    for g in tous_groupes_id:
        #gp=db(db.auth_group.id==g.id).select(db.auth_group.ALL)[0]
        gp=g.id 
        if gp not in appartient:                 
            liste_groupes.append(g.role)
            liste_id.append(gp)  
    return (liste_id,liste_groupes)
