# coding: utf8

#########################################################################
## This scaffolding model makes your app work on Google App Engine too
#########################################################################

if request.env.web2py_runtime_gae: # if running on Google App Engine
    from gluon.contrib.gql import *  
    ### connect to Google BigTable
    db = GQLDB()
    ## and store sessions and tickets there
    session.connect(request, response, db=db)
    ### or use the following lines to store sessions in Memcache
    # from gluon.contrib.memdb import MEMDB
    # from google.appengine.api.memcache import Client
    # session.connect(request, response, db=MEMDB(Client()))
else: # else use a normal relational database
    # if not, use SQLite or other DB
    db = SQLDB('sqlite://storage.sqlite')  


#########################################################################
## uncomment the following line if you do not want sessions
#session.forget()
#########################################################################

#########################################################################
## Define your tables below, for example
##
## >>> db.define_table('mytable',SQLField('myfield','string'))
##
## Fields can be 'string','text','password','integer','double','boolean'
##       'date','time','datetime','blob','upload', 'reference TABLENAME'
## There is an implicit 'id integer autoincrement' field
## Consult manual for more options, validators, etc.
##
## More API examples for controllers:
##
## >>> db.mytable.insert(myfield='value')
## >>> rows=db(db.mytbale.myfield=='value).select(db.mytable.ALL)
## >>> for row in rows: print row.id, row.myfield
#########################################################################
db.define_table('Questions',db.Field('auteur_id','integer',writable=False),
                            db.Field('description','text'),
                            db.Field('visibilite','boolean',default=True,writable=False),
                            db.Field('resultat',default='{}',writable=False),
                            db.Field('nbr_votes','integer',default=0,writable=False),
                            db.Field('date_postee','datetime',default=request.now,writable=False),
                            db.Field('date_limite','datetime'),
                            db.Field('groupe','string',default='Public',writable=False),
                            db.Field('mode','string',default='condorcet',writable=False))                            
db.Questions.description.requires=IS_NOT_EMPTY()

db.define_table('Reponses',db.Field('Q_id',db.Questions,writable=False),
                           db.Field('titre','text'),
                           db.Field('visibilite','boolean',default=True,writable=False),
                           db.Field('resultat',writable=False),
                           db.Field('date_postee','datetime',default=request.now,writable=False))
db.Reponses.titre.requires=IS_NOT_EMPTY() 
db.Reponses.date_postee.requires=IS_DATETIME() 
                                 
db.define_table('Tags',db.Field('titre','string'))
db.Tags.titre.requires=[IS_NOT_EMPTY(),IS_NOT_IN_DB(db,'Tags.titre')]

db.define_table('Tags_Questions',db.Field('Q_id',db.Questions,writable=False),
                                 db.Field('T_id',db.Tags))

db.Tags_Questions.T_id.requires=IS_IN_DB(db,'Tags.id','%(titre)s')
Tagged_Questions=(db.Questions.id==db.Tags_Questions.Q_id)&(db.Tags.id==db.Tags_Questions.T_id)

db.define_table('Votes',db.Field('Q_id',db.Questions),
                        db.Field('U_id','integer'),
                        db.Field('D_id','integer',default=0),
                        db.Field('Buletin'),
                        db.Field('date_vote','datetime',default=request.now,writable=False))
                        
db.define_table('Delegues',db.Field('U_id','integer',writable=False),
                           db.Field('Presentation','text'),
                           db.Field('lien','string'))
                           
db.define_table('Questions_Delegues',db.Field('Q_id','integer'),
                                     db.Field('D_id','integer'),
                                     db.Field('argumentaire','text'))

db.define_table('Postulants',db.Field('U_id','integer',writable=False),
                             db.Field('Motivation','text'),
                             db.Field('G_id','integer'),
                             db.Field('date_post','datetime',default=request.now,writable=False))                                                                                                                


#########################################################################
## Here is sample code if you need:
## - email capabilities
## - authentication (registration, login, logout, ... )
## - authorization (role based authorization)
## - services (xml, csv, json, xmlrpc, jsonrpc, amf, rss)
## - crud actions
## comment/uncomment as needed
#########################################################################

from gluon.tools import *
auth=Auth(globals(),db)            # authentication/authorization
#auth.settings.create_user_groups=False
#auth.settings.on_failed_authorization=URL(r=request,c='default',f='non_membre')
auth.settings.login_url = URL(r=request,c='default',f='user', args='login')

auth.settings.table_user = db.define_table(
auth.settings.table_user_name,db.Field('first_name', length=128,default='',label='Nom',requires=IS_NOT_EMPTY()),
                              db.Field('last_name', length=128,default='',label='Prénom',requires=IS_NOT_EMPTY()),
                              db.Field('email', length=128,label='E-mail',default=''),
                              db.Field('password', 'password', readable=False,label='Password', requires=[CRYPT(),IS_NOT_EMPTY()]),
                              db.Field('registration_key', length=128,writable=False, readable=False,default=''))
auth.settings.table_user.email.requires = [IS_EMAIL(), IS_NOT_IN_DB(db, '%s.email' % auth.settings.table_user._tablename)]


auth.settings.table_group=db.define_table(
auth.settings.table_group_name,db.Field('role', length=128,default='',label='Nom du Groupe'),
                               db.Field('description', 'text'),
                               db.Field('lien', length=128,default=''),
                               db.Field('adhesion'),
                               db.Field('key','integer',default=0,writable=False))
auth.settings.table_group.adhesion.requires=IS_IN_SET(("parrainée","administrée"))
auth.settings.table_group.adhesion.widget = SQLFORM.widgets.radio.widget                                



#auth.settings.mailer=mail                    # for user email verification
auth.define_tables()# creates all needed tables

auth.messages.registration_successful='Vous vous êtes Enregistré avec succès, Bienvenue dans Demexp !'
auth.messages.logged_in='Connecté'
auth.messages.logged_out='Déconnecté'
auth.messages.access_denied = "Vous n'avez pas les droits suffisants pour accéder à cette page !"
auth.messages.email_sent = 'Email envoyé'
auth.messages.email_verified = 'Email vérifié'
auth.messages.invalid_email = 'Email non valide'
auth.messages.invalid_login = 'Login non valide'
auth.messages.mismatched_password = "Les mots de passes sont différents"
auth.messages.verify_email = 'Cliquez sur le lien http://...verify_email/%(key)s pour vérifier votre Email'
auth.messages.verify_email_subject = 'Password verification'
auth.messages.username_sent = "Votre nom d'utilisateur vous a été envoyé par Email"
auth.messages.new_password_sent = 'Un nouveau mot de passe vous a été envoyé par Email'
auth.messages.password_changed = 'Mot de passe changé'
auth.messages.retrieve_username = "Votre nom d'utilisateur est: %(username)s"
auth.messages.retrieve_username_subject = "Nom d'utilisateur retrouvé"
auth.messages.retrieve_password = 'Votre mot de passe est: %(password)s'
auth.messages.retrieve_password_subject = 'Mot de passe retrouvé'
auth.messages.profile_updated = 'Profil mis à jour'
auth.messages.new_password='Nouveau mot de passe'
auth.messages.old_password='Ancien mot de passe'

if auth.is_logged_in():
    db.Questions.auteur_id.default = auth.user.id                      
    db.Postulants.U_id.default=auth.user.id

db.Postulants.G_id.requires=IS_IN_DB(db,'auth_group.id','auth_group.role')


crud=Crud(globals(),db)            # for CRUD helpers using auth
service=Service(globals())         # for json, xml, jsonrpc, xmlrpc, amfrpc

## uncomment as necessary or consult docs for more options
#crud.settings.auth=auth           # (optional) enforces authorization on crud
#mail=Mail()                                  # mailer
#mail.settings.server='smtp.gmail.com:587'    # your SMTP server
#mail.settings.sender='you@gmail.com'         # your email
#mail.settings.login='username:password'      # your credentials
#auth.settings.mailer=mail         # for user email verification
#auth.settings.registration_requires_verification = True
#auth.settings.registration_requires_approval = True
#auth.messages.verify_email = \
#  'Click on the link http://.../verify_email/%(key)s to verify your email'
